/**
 * @file FileHandle.h
 * @author Copyright (c) 2014 ESET, spol. s r.o.
 */

#pragma once

#include <string>

// File handle helper with automatic cleanup (in destructor)
class CFileHandle
{
	HANDLE h;

public:

	CFileHandle() : h(INVALID_HANDLE_VALUE){}

	~CFileHandle();

	bool CFileHandle::Open(LPCWSTR FileName, bool Create = false);

	bool Read(void* Data, DWORD Count, DWORD *Read = NULL);

	bool Write(void* Data, DWORD Count);

	bool Seek(int Offset, DWORD Direction);

	void Close();

	operator HANDLE();
};


// Text file writing with encoding support
class CTextFile : public CFileHandle
{
	DWORD CodePage;

public:

	CTextFile(DWORD CodePage=CP_ACP): CodePage(CodePage) {};

	bool WriteLN();

	bool WriteText(const std::wstring &Text);

	bool WriteLine(const std::wstring &Line);
};

