/**
 * @file CommandListParser.h
 * @author Copyright (c) 2014 ESET, spol. s r.o.
 */

#pragma once

class CommandListParser
{

public:
	CommandListParser(const std::wstring &input);

	StringVector GetCommands();

private:
	void ResetPosition();
	void GoToNextImportantChar();
	void Advance();

	void AppendRemainingInput();
	void AppendCurrentChar();
	void AddCurrentCommandToResult();

	bool IsAtEnd() const;
	bool IsAtCommandEnd() const;
	bool IsAtQuote() const;
	bool IsAtCommentBegin() const;
	bool IsAtFileReplacementMark() const;
	bool IsAtLineEnd() const;

private:
	const std::wstring &input;

	std::wstring::size_type pos;
	bool inQuotes;
	bool inComment;
	bool inFileReplacement;
	std::wstring::size_type currentPartBegin;

	std::wostringstream currentCommand;
	StringVector commands;

	wchar_t comma;
	wchar_t endOfLine;
	wchar_t quote;
	wchar_t commentBegin;
	wchar_t fileReplacementMark;

	std::wstring importantChars;

};

