/**
 * @file Element.cpp
 * @author Copyright (c) 2013 ESET, spol. s r.o.
 */

#include "set_nod.h"
#include "Element.h"

#include "Token.h"

std::wstring ElementWord::GetString() const
{
	std::wstring result;
	for (size_t i = 0; i < tokenList.size(); ++i)
	{
		if (i > 0) result += L" ";
		result += tokenList[i]->text;
	}
	return result;
}

std::vector<const ElementWord *> ElementWord::GetWords() const
{
	std::vector<const ElementWord *> result;
	result.push_back(this);

	return result;
}

std::wstring ElementWordList::GetString() const
{
	std::wstring result;

	size_t i = 0;
	for (; i < wordList.size() - 1; ++i)
		result += wordList[i]->GetString() + L",";

	result += wordList[i]->GetString();

	return result;
}

std::vector<const ElementWord *> ElementWordList::GetWords() const
{
	std::vector<const ElementWord *> result;
	result.resize(wordList.size());

	std::transform(
		wordList.begin(),
		wordList.end(),
		result.begin(),
		[](const std::shared_ptr<ElementWord> &element) { return element.get(); }
	);

	return result;
}

std::wstring ElementArrayToString(elementArray &elements)
{
	std::wstring line;
	for (size_t i = 0; i < elements.size(); ++i)
	{
		if (i > 0) line += L" ";
		line += elements[i]->GetString();
	}
	return line;
}
