/**
 * @file Token.cpp
 * @author Copyright (c) 2013 ESET, spol. s r.o.
 */

#include "set_nod.h"
#include "Token.h"

Token::Token(const std::wstring &tokenText, Token::TokenType tokenType) : text(tokenText), type(tokenType)
{

}


std::wstring Token::GetTokenTypeAsString(TokenType type)
{
#define RETURNENUMSTRING(b) if (type == b) return L#b;
	RETURNENUMSTRING(token_text)
	RETURNENUMSTRING(token_comma)
	RETURNENUMSTRING(token_operators_start)
	RETURNENUMSTRING(token_operators1_start)
	RETURNENUMSTRING(token_memberof)
	RETURNENUMSTRING(token_policyis)
	RETURNENUMSTRING(token_operators1_end)
	RETURNENUMSTRING(token_operators2_start)
	RETURNENUMSTRING(token_equals)
	RETURNENUMSTRING(token_notequals)
	RETURNENUMSTRING(token_greater)
	RETURNENUMSTRING(token_less)
	RETURNENUMSTRING(token_greaterequal)
	RETURNENUMSTRING(token_lessequal)
	RETURNENUMSTRING(token_like)
	RETURNENUMSTRING(token_notlike)
	RETURNENUMSTRING(token_in)
	RETURNENUMSTRING(token_notin)
	RETURNENUMSTRING(token_operators2_end)
	RETURNENUMSTRING(token_operators_end)
#undef RETURNENUMSTRING
	return L"ERROR";
}

std::wstring TokenArrayToString(tokenArray::iterator beginIt, tokenArray::iterator endIt)
{
	bool lastTokenIsComma = false;
	std::wstring line;
	while (beginIt != endIt)
	{
		if (!(lastTokenIsComma || (*beginIt)->type == Token::token_comma || line.empty()))
		{
			line += L" ";
		}
		line += (*beginIt)->text;
		lastTokenIsComma = ((*beginIt)->type == Token::token_comma);
		beginIt++;
	}
	return line;
}
