/**
 * @file Command_ClientNew.cpp
 * @author Copyright (c) 2014 ESET, spol. s r.o.
 */

#include "set_nod.h"
#include "Command_ClientNew.h"

#include <Common/era_api/era_api.h>
#include <Common/era_api/err_codes.h>
#include <Common/scope_exit.h>
#include "../Element.h"
#include "../util/apiUtils.h"
#include "../EracmdExceptions.h"

void Command_ClientNew::Execute(elementArray &elements, OutputHandler &out)
{
	Era_ClientList *clients = ElementToClientList(GetArgument(0));
	scope_exit se_clients(std::bind(era_ClientList_delete, clients));

	bool set = false;
	std::wstring setStr = GetArgument(1)->GetString();
	if (_wcsicmp(setStr.c_str(), L"set")==0)
		set = true;
	else if (_wcsicmp(setStr.c_str(), L"reset")==0)
		set = false;

	uint32_t result_clientNew = era_Client_new(clients, set);
	if (result_clientNew != 0)
	{
		throw EraCMDException_FromApi(result_clientNew);
	}
}

