/**
 * @file Command_PolicyExport.cpp
 * @author Copyright (c) 2014 ESET, spol. s r.o.
 */

#include "set_nod.h"
#include "Command_PolicyExport.h"

#include <Common/era_api/era_api.h>
#include <Common/era_api/err_codes.h>
#include "../util/stringUtils.h"
#include "../EracmdExceptions.h"
#include "../Element.h"

void Command_PolicyExport::Execute(elementArray &elements, OutputHandler &out)
{
	std::vector<uint32_t> idList;
	
	// policy id
	bool all = false;
	int policyId=0;
	std::wstring policyIdArg = GetArgumentAsString(0);

	if (_wcsicmp(policyIdArg.c_str(), L"*") == 0)
		all = true;
	else
	{
		if (_wcsicmp(policyIdArg.c_str(), L"!defaultclientspolicy") == 0)
			policyId = 0;
		else
			policyId = GetNumParam(0);
	}

	//2nd parameter
	std::wstring xmlFile = GetArgument(1)->GetString();

	// 3rd parameter - tree
	std::wstring tree;
	if (std::shared_ptr<Element> arg = GetArgument(2))
		tree = arg->GetString();
	

	uint32_t result = era_Policy_export(policyId, all, _wcsicmp(tree.c_str(), L"FALSE") != 0, xmlFile.c_str() );

	if (result != 0)
		throw EraCMDException_FromApi(result);
}
