/**
 * @file Command_PolicyRuleExport.cpp
 * @author Copyright (c) 2014 ESET, spol. s r.o.
 */

#include "set_nod.h"
#include "Command_PolicyRuleExport.h"

#include <Common/era_api/era_api.h>
#include <Common/era_api/err_codes.h>
#include "../util/stringUtils.h"
#include "../EracmdExceptions.h"
#include "../Element.h"

void Command_PolicyRuleExport::Execute(elementArray &elements, OutputHandler &out)
{
	std::vector<uint32_t> idList;

	// 1st parameter
	if (GetArgument(0)->GetString() != L"*")
	{
		std::vector<const ElementWord*> items = GetArgument(0)->GetWords();
		for (size_t i = 0; i < items.size(); i++)
		{
			std::wstring id = items[i]->GetString();
			try
			{
				idList.push_back(WstringToUint(id));
			} catch (...)
			{
				throw EraCMDException(CMDERROR_NUMBER_EXPECTED_IN_ID_LIST, id.c_str());
			}
		}
	}

	// 2nd parameter
	std::wstring xmlFile = GetArgument(1)->GetString();

	uint32_t result = era_PolicyRule_export(idList.empty() ? NULL : &idList[0], (uint32_t) idList.size(), xmlFile.c_str());
	if (result != 0)
		throw EraCMDException_FromApi(result);
}
