/**
 * @file Command_ReportBase.h
 * @author Copyright (c) 2014 ESET, spol. s r.o.
 */

#include "set_nod.h"
#include "Command_ReportBase.h"

#include <Common/era_api/era_api.h>
#include <Common/era_api/err_codes.h>
#include "../util/stringUtils.h"
#include "../Element.h"
#include "../EracmdExceptions.h"

bool Command_ReportBase::FillReportParams(const int argNumOffset, Era_ReportTemplateParams &params, bool skipTypeAndName)
{
	bool bAtLeastOneParam = false;
	int skipOffset;
	if (!skipTypeAndName)
	{	
		{
			const std::wstring elementStr = GetArgument(argNumOffset + 0)->GetString();

			if (_wcsicmp(elementStr.c_str(), L"static") == 0)
				era_ReportTemplateParams_SetType(&params, false);
			if (_wcsicmp(elementStr.c_str(), L"dashboard") == 0)
				era_ReportTemplateParams_SetType(&params, true);
			bAtLeastOneParam = true;
		}

		{
			const std::wstring elementStr = GetArgument(argNumOffset + 1)->GetString();

			era_ReportTemplateParams_SetName(&params, elementStr.c_str());
			bAtLeastOneParam = true;
		}
		skipOffset = 0;
	}
	else
		skipOffset = 2;

	if (std::shared_ptr<Element> element = GetArgument(argNumOffset - skipOffset + 2))
	{
		era_ReportTemplateParams_SetConfigXml(&params, element->GetString().c_str());
		bAtLeastOneParam = true;
	}

	if (std::shared_ptr<Element> element = GetArgument(argNumOffset - skipOffset + 3))
	{
		const std::wstring elementStr = element->GetString();

		if (_wcsicmp(elementStr.c_str(), L"TRUE") == 0)
			era_ReportTemplateParams_SetActive(&params, ERA_REPORT_TEMPLATE_FLAG_STATE__SET);
		if (_wcsicmp(elementStr.c_str(), L"FALSE") == 0)
			era_ReportTemplateParams_SetActive(&params, ERA_REPORT_TEMPLATE_FLAG_STATE__UNSET);
		bAtLeastOneParam = true;
	}

	if (std::shared_ptr<Element> element = GetArgument(argNumOffset - skipOffset + 4))
	{
		era_ReportTemplateParams_SetDescription(&params, element->GetString().c_str());
		bAtLeastOneParam = true;
	}

	return bAtLeastOneParam;
}
