/**
 * @file Command_ReportImport.cpp
 * @author Copyright (c) 2014 ESET, spol. s r.o.
 */

#include "set_nod.h"
#include "Command_ReportImport.h"

#include <Common/era_api/err_codes.h>
#include "../util/stringUtils.h"
#include "../Element.h"
#include "../EracmdExceptions.h"

void Command_ReportImport::Execute(elementArray &elements, OutputHandler &out)
{
	std::wstring reportType = GetArgument(0)->GetString();
	bool dashboard = (_wcsicmp(reportType.c_str(), L"dashboard") == 0);

	std::wstring file = GetArgument(1)->GetString();

	uint32_t result_reportImport = era_ReportTemplate_import(file.c_str(), dashboard);
	if (result_reportImport != 0)
	{
		throw EraCMDException_FromApi(result_reportImport);
	}
}

