/**
 * @file Command_Restart.cpp
 * @author Copyright (c) 2014 ESET, spol. s r.o.
 */

#include "set_nod.h"
#include "Command_Restart.h"

#include "../ScriptInterpreter.h"
#include "../Element.h"
#include "../EracmdExceptions.h"
#include "../util/stringUtils.h"
#include <Common/era_api/err_codes.h>


void Command_Restart::Execute(elementArray &elements, OutputHandler &out)
{
	std::wstring arg = GetArgumentAsString(0);
	bool full = (_wcsicmp(arg.c_str(), L"FULL") == 0);
	DWORD rc = era_ServerRestart(full);

	if (rc != ERAERROR_SUCCESS)
		throw EraCMDException_FromApi(rc);

	std::wstring info = LoadStringFromResource(IDS_CONSOLE_DISCONNECTED);
	out.PrintRaw(info);

	si.Exit();
}

