/**
 * @file Command_RunScript.h
 * @author Copyright (c) 2013 ESET, spol. s r.o.
 */

#pragma once

#include "../flags/CommandFlagsStack.h"
#include "../Command.h"

class Command_RunScript : public Command
{
public:
	Command_RunScript(CommandFlagsStack &commandFlagsStack, bool &partiallyFailed, int recursionDepth);
	virtual void Execute(elementArray &elements, OutputHandler &out) override;

	GENERATE_HELP_ID_METHODS(SCRIPT)

	static std::wstring GetCurrentFileName();

protected:
	static std::vector<std::wstring> scriptFileStack;
	CommandFlagsStack &commandFlagsStack;
	bool &partiallyFailed;
	int recursionDepth;
};

