/**
 * @file Command_Show.h
 * @author Copyright (c) 2014 ESET, spol. s r.o.
 */

#pragma once

#include "../flags/CommandFlagsStack.h"
#include "../Command.h"

struct Era_Query;
class Command_Show : public Command
{
public:
	Command_Show(CommandFlagsStack &commandFlagsStack);

	virtual void Execute(elementArray &elements, OutputHandler &out) override;

	GENERATE_HELP_ID_METHODS(SHOW)

private:
	static void SetColumns(const Element &element, Era_Query &query, bool & isCountOnly);
	static void SetConditions(const Element &element, Era_Query &query);
	static void SetGroupBy(const Element &element, Era_Query &query);
	static void SetOrderBy(const Element &element, Era_Query &query);
	static void SetSkip(const Element &element, Era_Query &query);
	static void SetLimit(const Element &element, Era_Query &query);

	void DoData(Era_Query &query, OutputHandler &out);
	void DoCount(Era_Query &query, OutputHandler &out);

private:
	CommandFlagsStack &commandFlagsStack;

};

