/**
 * @file CommandFlags.cpp
 * @author Copyright (c) 2013 ESET, spol. s r.o.
 */

#include "set_nod.h"
#include "CommandFlags.h"

#include "../flags/FlagsRegistry.h"

extern FlagsRegistry gFlagsRegistry;

CommandFlags::CommandFlags()
:
	checkOnly(false),
	continueOnError(false),
	paged(false),
	outputFormatting(FORMAT_CSV),
	outputCSVDelimiter(L''),
	outputEncoding(ENCODING_UTF8),
	outputMode(MODE_OVERWRITE),
	logEncoding(ENCODING_UTF8),
	headerType(HEADER_KEYWORD),
	fieldFormatting(FIELD_KEYWORD),
	tableClip(true),
	color(true)
{
}

#ifdef _DEBUG
std::wostream& operator<<(std::wostream &os, const CommandFlags &cf)
{
	const FlagsRegistry::Flags &flags = gFlagsRegistry.GetSupportedFlags();
	for (FlagsRegistry::Flags::const_iterator it = flags.begin(); it != flags.end(); ++it)
	{
		os
			<< (*it)->GetName()
			<< ": "
			<< (*it)->GetFrom(cf)
			<< std::endl;
		;
	}

	return os;
}
#endif

