/**
 * @file TextWidth_File.cpp
 * @author Copyright (c) 2014 ESET, spol. s r.o.
 */

#include "set_nod.h"
#include "TextWidth_File.h"

size_t TextWidth_File::GetWidth(const std::wstring &str) const
{
	return str.size();
}

std::wstring TextWidth_File::AlignTo(const std::wstring &str, const size_t width) const
{
	if (str.size() > width)
	{
		return str.substr(0, width);
	}

	if (str.size() < width)
	{
		return str + std::wstring(width - str.size(), L' ');
	}

	return str;
}

