/**
 * @file fileUtils.cpp
 * @author Copyright (c) 2013 ESET, spol. s r.o.
 */

#include "set_nod.h"
#include "fileUtils.h"

#include <Common/era_api/era_api.h>
#include <Common/era_api/err_codes.h>

bool FileExists(LPCWSTR FileName)
{
	WIN32_FIND_DATA fd;
	HANDLE h = FindFirstFile(FileName, &fd);
	if (h == NULL || h == INVALID_HANDLE_VALUE)
		return false;
	DWORD attr = fd.dwFileAttributes;
	FindClose(h);
	return (attr & FILE_ATTRIBUTE_DIRECTORY) == 0;
}

std::wstring GetProgramDataFilePath(const std::wstring &fileName)
{
	std::wstring absoluteFilePath;

	{
		wchar_t *str;
		if (era_GetLocalEraPath2(ERA_LOCAL_PATH_TYPE__APPLICATION_DATA_DIR, &str) == ERAERROR_SUCCESS)
		{
			absoluteFilePath = str;
			era_DeleteString(str);
		}
	}

	if (absoluteFilePath.empty())
	{
		WCHAR tmp[MAX_PATH] = {0};
		GetTempPath(MAX_PATH, tmp);
		absoluteFilePath = tmp;
	}

	if (absoluteFilePath.back() != L'\\')
		absoluteFilePath += L'\\';

	absoluteFilePath += fileName;

	return absoluteFilePath;
}

